#include <xdc/std.h>
#include <c6x.h>
#include "ti/fftlib/fftlib.h"

float *ptr_x_i;
float *ptr_y_i;
float *ptr_w_i;

void fft_memory_request (int nbufs, FFTmemBuffer_t *bufs)
{
  bufs[0].base = ptr_x_i;
  bufs[1].base = ptr_y_i;
  bufs[2].base = ptr_w_i;
} /* fft_memory_request */

void fft_memory_release(int nbufs, FFTmemBuffer_t *bufs)
{
  return;
}

void FFT_plan_1d_sp_r2c_facade (int N, float *in, float *out, float *tw,
                                int type, int   mode, char *plan)
{
    fft_plan_t p;
    fft_callout_t          plan_fxns;

    /* initalize callout functions */
    plan_fxns.memoryRequest   = fft_memory_request;
    plan_fxns.ecpyRequest     = 0;
    plan_fxns.memoryRelease   = fft_memory_release;
    plan_fxns.ecpyRelease     = 0;

    ptr_x_i= (float * ) in;
    ptr_y_i= (float *) out;
    ptr_w_i= (float *) tw;

//    p = FFT_plan_1d_sp_r2c(N, in, out, tw, type, mode);
    p = fft_sp_plan_1d_r2c (N, FFT_DIRECT, plan_fxns);
    memcpy(plan, (char*)&p, sizeof(fft_plan_t));
}

void FFT_execute_facade(char *plan)
{
    fft_execute(*(fft_plan_t*)plan);
}

